﻿namespace UltraDayViewLines
{
    using System;
    using System.Drawing;
    using System.Drawing.Drawing2D;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinSchedule;

    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
            this.comboBox1.SelectedIndexChanged += ComboBox1_SelectedIndexChanged;
        }

        private void ComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            var combo = sender as ComboBox;
            if(combo == null)
                return;

            //  Set the TimeSlotInterval and update the draw filter
            this.ultraDayView1.TimeSlotInterval = (TimeSlotInterval)Enum.Parse(typeof(TimeSlotInterval),combo.SelectedItem.ToString());
            ((DF)this.ultraDayView1.DrawFilter).Intervals = this.Intervals;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //  Create custom pen to draw the lines
            var pen = new Pen(Color.Red);
            pen.DashCap = DashCap.Flat;
            pen.DashStyle = DashStyle.Dash;

            //  Set the DrawFilter of the day view and pass the pen to draw the lines
            this.ultraDayView1.DrawFilter = new DF(pen, this.Intervals);

            //  Setup the combo allowing you to change the TimeSlotIntervals of the DayView at runtime
            this.comboBox1.Items.AddRange(Enum.GetNames(typeof(TimeSlotInterval)));
            this.comboBox1.SelectedIndex = 8;
        }

        /// <summary>
        /// Gets the number of intervals according to TimeSlotInterval of the DayView
        /// </summary>
        #region Intervals
        private int Intervals
        {
            get
            {
                var intervals = 0;
                switch(this.ultraDayView1.TimeSlotInterval)
                {
                    case TimeSlotInterval.SixtyMinutes:
                        intervals = 1;
                        break;
                    case
                    TimeSlotInterval.ThirtyMinutes:
                        intervals = 2;
                        break;
                    case TimeSlotInterval.TwentyMinutes:
                        intervals = 3;
                        break;
                    case TimeSlotInterval.FifteenMinutes:
                        intervals = 4;
                        break;
                    case TimeSlotInterval.TwelveMinutes:
                        intervals = 5;
                        break;
                    case TimeSlotInterval.TenMinutes:
                        intervals = 6;
                        break;
                    case TimeSlotInterval.SixMinutes:
                        intervals = 10;
                        break;
                    case TimeSlotInterval.FiveMinutes:
                        intervals = 12;
                        break;
                    case TimeSlotInterval.FourMinutes:
                        intervals = 15;
                        break;
                    case TimeSlotInterval.ThreeMinutes:
                        intervals = 20;
                        break;
                    case TimeSlotInterval.TwoMinutes:
                        intervals = 30;
                        break;
                    case TimeSlotInterval.OneMinute:
                        intervals = 60;
                        break;
                }

                return intervals;
            }
        }
        #endregion Intervals
    }
}
